#include "libgraph.h"
#include "image.h"
#include <memory.h>

value caml_gr_make_image(value m)
{
  int width, height;
  value im;
  int i, j;

  caml_gr_check_open();
  height = Wosize_val(m);
  if (height == 0) return caml_gr_new_image(0, 0);
  width = Wosize_val(Field(m, 0));
  for (i = 1; i < height; i++)
    if (Wosize_val(Field(m, i)) != width)
      caml_gr_fail("make_image: lines of different lengths", NULL);

  im = caml_gr_new_image(width, height);
	char* data = (char*)Data_im(im);
	for (i = 0; i <height; i++)
	{
		for (j = 0; j <width; j++)
		{
			int x = Int_val(Field(Field(m, i), j));
			int r = x >> 16;
			int g = (x >> 8) & 0xff;
			int b = x & 0xff;
			if (x == -1) 
			{
				*data++ = 0xff;
				*data++ = 0xff;
				*data++ = 0xff;
				*data++ = 0;
			}
			else
			{
				*data++ = r;
				*data++ = g;
				*data++ = b;
				*data++ = 0xff;			
			}
		}
	}	

  return im;
}
