#include "libgraph.h"
#import <Cocoa/Cocoa.h>

extern NSBitmapImageRep* bitmap;
extern NSLock* lock;
extern BOOL needsRefresh;
extern int width, height;

value caml_gr_point_color(value vx, value vy)
{
    caml_gr_check_open();
    int ax = Int_val(vx);
    int ay = Int_val(vy);
    
	if (ax < 0 || ax >= width || ay < 0 || ay >= height) return Val_int(16777215); // white pixel
	unsigned char* buffer = [bitmap bitmapData];
	int i = ((height - ay - 1) * width + ax) * 4;
	[lock lock];
	unsigned int r = buffer[i++];
	unsigned int g = buffer[i++];
	unsigned int b = buffer[i];
	unsigned int rgb = r * 65536 + g * 256 + b; 
	[lock unlock];
    
    return Val_int(rgb);
}


